// BMFBioUPIDemoTrt.cpp : implementation file
//

#include "stdafx.h"
#include "BMFBioUPIDemo.h"
#include "BMFBioUPIDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#include <io.h>
#include <fcntl.h>
#include <stdlib.h>


int	Detect( unsigned char *imagin, signed short th, short *pdisp);


void	SaveToFile(unsigned char * img, int size, int i)
{
int	handle;
char nf[16];

sprintf(nf, "mbf_200%d.bin", i);

handle = _open(nf,O_CREAT|O_BINARY|O_WRONLY);
if ( handle == -1 )	return;

_write(handle, img, size);

_close(handle);
}


UINT	CBMFBioUPIDemoDlg::ThreadScanner(LPVOID Par)
{
CBMFBioUPIDemoDlg* m_Dlg = (CBMFBioUPIDemoDlg*)Par;

// Startup Sensor
m_Dlg->rc=ufisStartupSensor(DevHand);
	
while(1) {
	WaitForSingleObject(m_Dlg->s_DoEvent,INFINITE);

	if  ( TreatStatus == FALSE )	break;
	// test on finger

	m_Dlg->rc = ufisIsFingerPresent(DevHand);
	//test return code
	if ( m_Dlg->rc == rcOK ) {

		m_Dlg->pimg = ufisGetImage(DevHand);

		m_Dlg->Himg = ufisGetHeight(DevHand);
		m_Dlg->Wimg = ufisGetWidth(DevHand);


		m_Dlg->MyPaint();
		m_Dlg->ControlEvents();
		//m_Dlg->MyPaint();

		
		// Startup Sensor
		m_Dlg->rc = ufisStartupSensor(DevHand);
	}

	if  ( TreatStatus == FALSE )	break;
}
return	0;
}



int	CBMFBioUPIDemoDlg::ControlEvents(void)
{
char	msg[128];
int	ret;
CWnd* pWnd = GetDlgItem(IDC_STATUSINFO);


if  ( m_IsEnroll == TRUE ) {
	counter++;
	if  ( counter == 1 ) {
		counter = 0;

		//ret = match->V2_CreateTemplate(pimg, Wimg, Himg, btmp, status);
		//ret = match->CreateTemplate(pimg, Wimg, Himg, btmp, status);
		ret = CreateTemplate(pimg, Wimg, Himg, btmp, &status);

		if  ( ret == 0 ) {
			SetDlgItemText(IDC_STATUSINFO,"Take away the finger");
			//MessageBox("Take away the finger","Enrollment", MB_OK | MB_ICONASTERISK |MB_ICONINFORMATION);
			sprintf(msg, "Please, put your finger on the scanner (%d)", status);
			SetDlgItemText(IDC_STATUSINFO, msg);
		}
		if  ( ret == 1 ) {
			ret = GetQualityTemplate(btmp);


			SetDlgItemText(IDC_STATUS,    "");
			SetDlgItemText(IDC_STATUSINFO,"");
			m_IsEnroll = FALSE;
			MessageBox("Templete is created", "Enrollment", MB_OK | MB_ICONASTERISK |MB_ICONINFORMATION);
//			if ( MessageBox("Templete is created. Does it save to card?", "Enrollment", MB_OKCANCEL | MB_ICONASTERISK |MB_ICONINFORMATION) == IDOK ) {
//				dev.ufisWriteCard(btmp,2048, &ret);
//				MessageBox("Templete is saved to card.", "Enrollment", MB_OK | MB_ICONASTERISK |MB_ICONINFORMATION);
//			}
		}

		
	}
}

if  ( m_IsComp1to1 == TRUE ) {

//	if ( MessageBox("Does image compare with tempalte on the card?", "Verification", MB_OKCANCEL | MB_ICONASTERISK |MB_ICONINFORMATION) == IDOK ) {
//		dev.ufisReadCard(btmp,2048, &ret);
//	}

//	ret = match->V2_Verify(pimg, Wimg, Himg, btmp);
//	ret = match->Verify(pimg, Wimg, Himg, btmp);

	ret = Verify(pimg, Wimg, Himg, btmp);

	counter++;
	if  ( ret >= 33 ) {
		//sprintf(msg, "Person is verified %d", ret);
		ufisControlLED(DevHand, LED_GREEN_ON);
		sprintf(msg, "Person is verified");
		MessageBox(msg, "Verification", MB_OK | MB_ICONASTERISK |MB_ICONINFORMATION);
		//Sleep(1000);
		ufisControlLED(DevHand, LED_GREEN_OFF);
		counter = 0;
	}
	else {
		if ( counter == 1 )	return	1;
		ufisControlLED(DevHand, LED_RED_ON);
		sprintf(msg, "Person is not verified");
		MessageBox(msg, "Verification", MB_OK | MB_ICONASTERISK |MB_ICONINFORMATION);
		//Sleep(1000);
		ufisControlLED(DevHand, LED_RED_OFF);
		counter = 0;
	}
}


return	1;
}


